package hellocucumber;

import io.cucumber.java.After;
import io.cucumber.java.Before;
import io.cucumber.java.Scenario;
import io.cucumber.java.en.Given;
import io.cucumber.java.en.Then;
import io.cucumber.java.en.When;
import org.junit.Assert;
import org.openqa.selenium.OutputType;
import org.openqa.selenium.TakesScreenshot;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.chrome.ChromeDriver;
import org.openqa.selenium.support.PageFactory;

public class AmazonSearchSteps {

    private WebDriver driver;

    @Before
    public void setUp() {
        System.setProperty("webdriver.chrome.driver", "/usr/local/bin/ChromeDriver");
        driver = new ChromeDriver();
    }

    @After
    public void tearDown(Scenario scenario) {
        if (scenario.isFailed()) {
            final byte[] screenshot = ((TakesScreenshot) driver).getScreenshotAs(OutputType.BYTES);
            scenario.attach(screenshot, "image/png", "amazon");
        }
        closeBrowser();
    }

    @Given("^I navigated to Google$")
    public void i_navigated_to_Google() throws Throwable {
        driver.get("http://www.google.com");
    }

    @When("^I searched for Amazon$")
    public void i_searched_for_Amazon() throws Throwable {
        HomePage page = PageFactory.initElements(driver, HomePage.class);
        page.setSearchBox("Amazon");
        page.clickSubmit();
    }

    @Then("^the result should show for Amazon$")
    public void the_result_should_show_for_Amazon() throws Throwable {
        Assert.assertTrue(driver.getTitle().contains("Amazon"));
    }

    void closeBrowser() {
        driver.quit();
    }
}
