package hellocucumber;

import io.cucumber.java.Before;
import io.cucumber.java.en.Given;
import io.cucumber.datatable.DataTable;
import io.cucumber.java.en.Then;
import io.cucumber.java.en.When;
import static org.junit.Assert.assertEquals;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class BookStoreSteps {
    private BookStore store = new BookStore();
    private List<Book> foundBooks;

    @Before
    public void setUp() {
        foundBooks = new ArrayList<>();
    }

    @Given("^I have the following books in the store$")
    public void i_have_the_following_books_in_the_store(DataTable data) {

        List<Map<String, String>> rows = data.asMaps(String.class, String.class);

        for (Map<String, String> columns : rows) {
            store.addBook(new Book(columns.get("title"), columns.get("author")));
        }
    }

    @When("^I search for books by author Erik Larson$")
    public void i_search_for_books_by_author_Erik_Larson() throws Throwable {
        foundBooks = store.booksByAuthor("Erik Larson");
    }

    @Then("^I find (\\d+) books$")
    public void i_find_books(int arg1) throws Throwable {
        assertEquals(arg1, foundBooks.size());
    }
}
